<?

/*

PAccounts Class 0.1 (April 27, 2000)
a web account password manager
http://www.dansteinman.com/php/paccounts/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)

This is free software under the terms of the GNU General Public License

*/

class PAccounts {

	function setDB($db) {
		$this->db = $db;
		$result = $this->db->query("select * from paccounts");
		if (!$result) {
			$this->createTable();
		}
	}
	function createTable() {
		$this->db->query("create table paccounts (username VARCHAR(255), account VARCHAR(255), action VARCHAR(255), method VARCHAR(255), inputs VARCHAR(255))");
	}

	function getSavedForms() {
		global $username;
		
		$forms = array();
		
		$result = $this->db->query("select * from paccounts where(username=\"$username\")");
		
		while ($row = $this->db->fetch_array($result)) {
			$l = count($forms);
			$forms[$l] = array(
				'formname' => "paccountsform$l",
				'account' => $row['account'],
				'action' => $row['action'],
				'method' => $row['method'],
				'inputs' => array()
			);

			$inputs = split('&',$row['inputs']);
			for ($i=0;$i<count($inputs);$i++) {
				$keyval = split('=',$inputs[$i]);
				$name = $keyval[0];
				$value = $keyval[1];
				$forms[$l]['inputs'][] = array("$name" => $value);
			}
		}
		
		return $forms;
	}
	
	function getHiddenFormsString() {
		$str = "";
		
		$forms = $this->getSavedForms();
	
		for ($i=0;$i<count($forms);$i++) {
			$formname = $forms[$i]['formname'];
			$action = $forms[$i]['action'];
			$method = $forms[$i]['method'];
			$inputs = $forms[$i]['inputs'];
		
			$str = "$str\n<form name=\"$formname\" action=\"$action\" method=\"$method\">\n";
		
			for ($j=0;$j<count($inputs);$j++) {
				list($name,$value) = each($inputs[$j]);
				$str = "$str<input type=\"hidden\" name=\"$name\" value=\"$value\">\n";
			}
			
			$str = "$str</form>";
		}
		return $str;
	}

	function displayEditAccounts() {	
		global $username;

		// this is a javascript function to submit the hidden form
		print '	
		<script language="JavaScript">
		
		function PAccountsLogin(formname) {
			document[formname].submit()
		}
	
		</script>
		';

		print "<h3>Edit Accounts for $username</h3>";
		print "<p><a href=\"paccounts.php3?command=makeaccount\">Make a new account</a>";
		
		$forms = $this->getSavedForms();
		
		print '
		<form action=paccounts.php3 method=post>
		<input type="hidden" name="command" value="deleteaccount">
		<table border=1>
		<tr><td><b>Account Name</b></td><td><b>Delete</b></td></tr>
		';
		
		for ($i=0;$i<count($forms);$i++) {
			$account = $forms[$i]['account'];  // the name of the account
			$formname = $forms[$i]['formname'];  // the name of the form to submit
	
			print "<tr><td><a href=\"javascript:PAccountsLogin('$formname')\">$account</a></td><td><input type=radio name=\"accounttodelete\" value=\"$formname\"></td></tr>";
		}
		print '
		<tr><td></td><td><input type=submit name="do" value="Delete"></td></tr>
		</table>
		</form>
		';
		
		// print the hidden forms necessary to login to the accounts
		print $this->getHiddenFormsString();		
	}

	function deleteAccount() {
		global $username, $accounttodelete;
		$forms = $this->getSavedForms();
		for ($i=0;$i<count($forms);$i++) {
			$account = $forms[$i]['account'];
			$formname = $forms[$i]['formname'];
			if ($accounttodelete == $formname) {
				$this->db->query("delete from paccounts where(username='$username' && account='$account')");
				$this->displayEditAccounts();
				$successful = true;
				break;
			}
		}
		if (!$successful) {
			print "Error: no account was selected";
		}
	}

	function displayMakeAccount() {
		print '
	
		<form action=paccounts.php3 method=post>
		<input type=hidden name=command value=submitmakeaccount>
		Enter the URL for the website you need to login to:<br>
		<input name=url value="http://localhost/myportal/paccounts-testurl.php3" size=45><br>
		<input type="submit">
		</form>
		
		<p>Example URLs:

		<p>Hotmail: http://lc4.law5.hotmail.passport.com/cgi-bin/login
		<br>Tip for Hotmail: the Hotmail site will determine that JavaScript is not available, so for the input named "js" the value will be "no", change it to "yes" to properly log in
		
		<p>My Ebay: http://cgi1.ebay.com/aw-cgi/eBayISAPI.dll?MyEbayLogin
		
		';
	}
	
	function displaySubmitMakeAccount($url) {
		$file = http_getFile($url);		
		$html = html_formatTags($file);
		$forms = html_parseForms($html);

		$numforms = count($forms);
		
		if ($numforms==0) {
			print "<p><b>Error:</b> No forms were found, try a different URL";
			return;
		}
		
		print "<h3>Results for $url</h3>";
			
		print '

		<script language="JavaScript">

		function submitForm(which) {
			var f = document[which];
			var s = document["submitform"];
			
			if (f.account.value == "enter a name") {
				alert("You must enter a unique account name")
				return
			}
			
			s.account.value = f.account.value
			s.action.value = f.action.value
			s.method.value = f.method.value
		
			var inputs = f.inputs.value.split(", ")
			var sinputs = "";
			
			for (var i=0;i<inputs.length;i++) {
				if (f[inputs[i]]) {
					sinputs += inputs[i]+"="+escape(f[inputs[i]].value)
					if (i<inputs.length-2) sinputs += "&";
				}
			}
			
			s.inputs.value = sinputs;
			
			s.submit();
		}
		
		</script>
		
		<form name="submitform" action=paccounts.php3 method=post>
		<input type=hidden name=command value=saveaccount>
		<input type=hidden name=account>
		<input type=hidden name=action>
		<input type=hidden name=method>
		<input type=hidden name=inputs>
		</form>

		';

		for ($i=0;$i<$numforms;$i++) {
			$action = $forms[$i]["action"];
			$method = $forms[$i]["method"];
			$inputs = $forms[$i]["inputs"];

			// fix action field
			if (!eregi("\:\/\/",$action)) {
				$server = eregi_replace("http://","",$url);
				if (ereg("/",$server)) {
					$server = substr($server,0,strrpos($server,"/"));
				}
				$action = "http://".$server."/".$action;
			}
			
			$num = count($inputs);
			
			print "
						
			<table border=1 cellpadding=2>
			<form name='form$i' method=post>

			<input type=hidden name='numinputs' value='$num'>
			<input type=hidden name='action' value='$action'>
			<input type=hidden name='method' value='$method'>

			<tr><td><b>Account Name</b></td><td colspan=2><input name=account value='enter a name' size=30></td></tr>
			<tr><td><b>URL</b></td><td colspan=2>$url</td></tr>
			<tr><td><b>Action</b></td><td colspan=2>$action</td></tr>
			<tr><td><b>Method</b></td><td colspan=2>$method</td></tr>
			<tr><td><b>Input Name</b></td><td><b>Type</b></td><td><b>Default Value</b></td></tr>			

			";
			
			$input = "";
			
			for ($j=0;$j<count($inputs);$j++) {
				$name = $inputs[$j][0];
				$type = $inputs[$j][1];
				$value = $inputs[$j][2];

				print "<tr><td>$name&nbsp;</td><td>$type&nbsp;</td><td><input name='$name' value='$value' size=20></td></tr>\n";
				
				$input = "$name, $input";
			}

			print "
			<input type=hidden name='inputs' value=\"$input\">
			<tr><td colspan=3><input type=button value='Save This Account' onclick=submitForm('form$i')></td></tr>
			</form>
			</table>
			";
		}
		
	}

	function displaySaveAccount() {
		global $username,$password,$account,$url,$action,$method,$inputs;
		$inputs = rawurldecode($inputs);

		$this->db->query("delete from paccounts where(username=\"$username\" && account=\"$account\")");
		$this->db->query("insert into paccounts VALUES(\"$username\",\"$account\",\"$action\",\"$method\",\"$inputs\")");
	
		print "
			The following account was saved:<p>
			$account<br>
			$action<br>
			$method<br>
			$inputs<br>
			
			<p><a href='paccounts.php3'>Return to PAccounts to try logging in</a>
		";
	}

	
}

?>
